---
title: ImageCapture.takePhoto()
slug: Web/API/ImageCapture/takePhoto
tags:
  - API
  - Experimental
  - Image
  - ImageCapture
  - Media
  - MediaStream Image Capture
  - Method
  - Reference
  - takePhoto
---
<div>{{APIRef("MediaStream Image")}}</div>

<p><span class="seoSummary">The <strong><code>takePhoto()</code></strong> method of the {{domxref("ImageCapture")}} interface takes a single exposure using the video capture device sourcing a {{domxref("MediaStreamTrack")}} and returns a {{jsxref("Promise")}} that resolves with a {{domxref("Blob")}} containing the data.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>blobPromise</em> = <em>imageCaptureObj</em>.takePhoto([<em>photoSettings</em>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>photoSettings</code> {{optional_inline}}</dt>
 <dd>An object that sets options for the photo to be taken. The available options are:
 <ul>
  <li><code>fillLightMode</code>:  The flash setting of the capture device, one of <code>"auto"</code>, <code>"off"</code>, or <code>"flash"</code>.</li>
  <li><code>imageHeight</code>: The desired image height as an integer. The user agent selects the closest height value to this setting if it only supports discrete heights.</li>
  <li><code>imageWidth</code>: The desired image width as an integer. The user agent selects the closest width value to this setting if it only supports discrete widths.</li>
  <li><code>redEyeReduction</code>: A boolean indicating whether the red-eye reduction should be used if it is available.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves with a {{domxref("Blob")}}.</p>

<h2 id="Example">Example</h2>

<p>This example is extracted from this <a href="https://simpl.info/imagecapture/">Simple Image Capture demo</a>. It shows how to use the {{jsxref("Promise")}} returned by <code>takePhoto()</code> to copy the returned {{domxref("Blob")}} to an {{htmlelement("img")}} element. For simplicy it does not show how to instantiate the {{domxref("ImageCapture")}} object.</p>

<pre class="brush: js">var takePhotoButton = document.querySelector('button#takePhoto');
var canvas = document.querySelector('canvas');

takePhotoButton.onclick = takePhoto;

function takePhoto() {
  imageCapture.takePhoto().then(function(blob) {
    console.log('Took photo:', blob);
    img.classList.remove('hidden');
    img.src = URL.createObjectURL(blob);
  }).catch(function(error) {
    console.log('takePhoto() error: ', error);
  });
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('MediaStream Image','#dom-imagecapture-takephoto','takePhoto()')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.ImageCapture.takePhoto")}}</p>
</div>
